import { h } from '@stencil/core';
import classNames from 'classnames';
export class IIIFGalleryItem {
    constructor() {
        this.selected = false;
    }
    renderLabel() {
        let label = this.item.getDefaultLabel();
        if (label) {
            return (h("div", { class: "ph2 ph0-ns pb3 link" },
                h("h3", { class: "f5 f4-ns mb0 black-90" }, label)));
        }
    }
    render() {
        let thumbnail = this.item.getThumbnail();
        const classes = classNames({
            'collection': this.item.isCollection(),
            'manifest': this.item.isManifest(),
            'canvas': this.item.isCanvas(),
            'selected': this.selected,
            'aspect-ratio': true,
            'aspect-ratio--1x1': true
        });
        return (h("div", { onClick: () => this._itemSelectedHandler(), class: "fl w-100 w-50-m  w-25-ns pa2" },
            h("div", { class: classes }, (thumbnail) ? h("img", { src: thumbnail.id, class: "db bg-center cover aspect-ratio--object" }) : h("span", null, "No thumbnail")),
            this.renderLabel()));
    }
    _itemSelectedHandler() {
        this.selectItem.emit(this.item);
    }
    static get is() { return "iiif-gallery-item"; }
    static get originalStyleUrls() { return {
        "$": ["iiif-gallery-item.css"]
    }; }
    static get styleUrls() { return {
        "$": ["iiif-gallery-item.css"]
    }; }
    static get properties() { return {
        "item": {
            "type": "any",
            "mutable": false,
            "complexType": {
                "original": "Manifesto.IManifestResource",
                "resolved": "any",
                "references": {
                    "Manifesto": {
                        "location": "global"
                    }
                }
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "item",
            "reflect": false
        },
        "selected": {
            "type": "boolean",
            "mutable": false,
            "complexType": {
                "original": "boolean",
                "resolved": "boolean",
                "references": {}
            },
            "required": false,
            "optional": false,
            "docs": {
                "tags": [],
                "text": ""
            },
            "attribute": "selected",
            "reflect": false,
            "defaultValue": "false"
        }
    }; }
    static get events() { return [{
            "method": "selectItem",
            "name": "selectItem",
            "bubbles": true,
            "cancelable": true,
            "composed": true,
            "docs": {
                "tags": [],
                "text": ""
            },
            "complexType": {
                "original": "any",
                "resolved": "any",
                "references": {}
            }
        }]; }
}
