var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { r as registerInstance, c as createEvent, h } from './chunk-c6ee5401.js';
var IIIFGallery = /** @class */ (function () {
    function IIIFGallery(hostRef) {
        registerInstance(this, hostRef);
        this.items = null;
        this.selectManifest = createEvent(this, "selectManifest", 7);
        this.selectCollection = createEvent(this, "selectCollection", 7);
        this.selectCanvas = createEvent(this, "selectCanvas", 7);
    }
    IIIFGallery.prototype.manifestHandler = function () {
        this._reset();
    };
    IIIFGallery.prototype.ignoreHandler = function () {
        this._reset();
    };
    IIIFGallery.prototype.componentWillLoad = function () {
        this._reset();
    };
    IIIFGallery.prototype._reset = function () {
        var _this = this;
        if (this.manifest) {
            manifesto.loadManifest(this.manifest).then(function (data) {
                var manifest = manifesto.create(data);
                // if it's a collection, list either the child collections or child manifests.
                if (manifest.isCollection()) {
                    _this.items = manifest.items;
                }
                else {
                    // if it's a manifest, list the child canvases.
                    var sequences = manifest.getSequences();
                    if (sequences.length) {
                        var sequence = sequences[0];
                        _this.items = sequence.getCanvases();
                    }
                }
                if (_this.ignore) {
                    // remove any whitespace in ignore csv
                    var ignore_1 = _this.ignore.split(',').map(function (item) { return item.trim(); });
                    _this.items = _this.items.filter(function (resource) { return ignore_1.indexOf(resource.id) === -1; });
                }
            }).catch(function (e) {
                console.error(e);
                console.error('failed to load manifest');
            });
        }
        else {
            this.items = null;
        }
    };
    IIIFGallery.prototype.reset = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this._reset();
                return [2 /*return*/];
            });
        });
    };
    IIIFGallery.prototype.render = function () {
        var _this = this;
        if (!this.items) {
            return (h("span", null));
        }
        else {
            return (h("section", { class: "cf w-100 pa2" }, this.items.map(function (item) { return h("iiif-gallery-item", { item: item, selected: _this._selectedItem === item }); })));
        }
    };
    IIIFGallery.prototype.itemSelected = function (event) {
        var item = event.detail;
        this._selectedItem = item;
        if (item.isCollection()) {
            this.selectCollection.emit(item);
        }
        else if (item.isManifest()) {
            this.selectManifest.emit(item);
        }
        else {
            this.selectCanvas.emit(item);
        }
    };
    Object.defineProperty(IIIFGallery, "watchers", {
        get: function () {
            return {
                "manifest": ["manifestHandler"],
                "ignore": ["ignoreHandler"]
            };
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(IIIFGallery, "style", {
        get: function () { return ""; },
        enumerable: true,
        configurable: true
    });
    return IIIFGallery;
}());
function createCommonjsModule(fn, module) {
    return module = { exports: {} }, fn(module, module.exports), module.exports;
}
var classnames = createCommonjsModule(function (module) {
    /*!
      Copyright (c) 2017 Jed Watson.
      Licensed under the MIT License (MIT), see
      http://jedwatson.github.io/classnames
    */
    /* global define */
    (function () {
        var hasOwn = {}.hasOwnProperty;
        function classNames() {
            var classes = [];
            for (var i = 0; i < arguments.length; i++) {
                var arg = arguments[i];
                if (!arg)
                    continue;
                var argType = typeof arg;
                if (argType === 'string' || argType === 'number') {
                    classes.push(arg);
                }
                else if (Array.isArray(arg) && arg.length) {
                    var inner = classNames.apply(null, arg);
                    if (inner) {
                        classes.push(inner);
                    }
                }
                else if (argType === 'object') {
                    for (var key in arg) {
                        if (hasOwn.call(arg, key) && arg[key]) {
                            classes.push(key);
                        }
                    }
                }
            }
            return classes.join(' ');
        }
        if (module.exports) {
            classNames.default = classNames;
            module.exports = classNames;
        }
        else {
            window.classNames = classNames;
        }
    }());
});
var IIIFGalleryItem = /** @class */ (function () {
    function IIIFGalleryItem(hostRef) {
        registerInstance(this, hostRef);
        this.selected = false;
        this.selectItem = createEvent(this, "selectItem", 7);
    }
    IIIFGalleryItem.prototype.renderLabel = function () {
        var label = this.item.getDefaultLabel();
        if (label) {
            return (h("div", { class: "ph2 ph0-ns pb3 link" }, h("h3", { class: "f5 f4-ns mb0 black-90" }, label)));
        }
    };
    IIIFGalleryItem.prototype.render = function () {
        var _this = this;
        var thumbnail = this.item.getThumbnail();
        var classes = classnames({
            'collection': this.item.isCollection(),
            'manifest': this.item.isManifest(),
            'canvas': this.item.isCanvas(),
            'selected': this.selected,
            'aspect-ratio': true,
            'aspect-ratio--1x1': true
        });
        return (h("div", { onClick: function () { return _this._itemSelectedHandler(); }, class: "fl w-100 w-50-m  w-25-ns pa2" }, h("div", { class: classes }, (thumbnail) ? h("img", { src: thumbnail.id, class: "db bg-center cover aspect-ratio--object" }) : h("span", null, "No thumbnail")), this.renderLabel()));
    };
    IIIFGalleryItem.prototype._itemSelectedHandler = function () {
        this.selectItem.emit(this.item);
    };
    Object.defineProperty(IIIFGalleryItem, "style", {
        get: function () { return ""; },
        enumerable: true,
        configurable: true
    });
    return IIIFGalleryItem;
}());
export { IIIFGallery as iiif_gallery, IIIFGalleryItem as iiif_gallery_item };
